//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import "UIViewController+Contact.h"
#import "PCContact+Additions.h"
#import "UIViewController+Alert.h"

@implementation UIViewController (Contact)

#pragma mark -

- (void)executeAction:(ContactAction)action forContact:(PCContact *)contact {
    
    switch (action) {
        case saveContactAction:
            [self saveContact:contact];
            break;
        default:
            break;
    }
}

#pragma mark -

- (void)saveContact:(PCContact *)contact {

    CNMutableContact *CNContact = [contact getCNContact];
    
    CNContactStore *contactStore = [CNContactStore new];
    CNSaveRequest *saveRequest = [CNSaveRequest new];
    [saveRequest addContact:CNContact toContainerWithIdentifier:nil];
    
    NSError *error = nil;
    [contactStore executeSaveRequest:saveRequest error:&error];
    
    if (error) {
        
        [self showOKAlertWithTitle:NSLocalizedString(@"Failed", nil)
                                 andMessage:NSLocalizedString(@"Failed to save contact in addressbook", nil)
                           attributedString:nil
                                   okAction:nil];
    } else {
        
        [self showOKAlertWithTitle:NSLocalizedString(@"Success", nil)
                                 andMessage:NSLocalizedString(@"Successfully saved contact in addressbook", nil)
                           attributedString:nil
                                   okAction:nil];
    }
}

#pragma mark -
#pragma mark Cancel
- (void)addCancelAction:(UIAlertController *)alertController {
    [self alertController:alertController
       addActionWithTitle:NSLocalizedString(@"Cancel", nil)
                    style:UIAlertActionStyleCancel
                andAction:nil];
}
#pragma mark -

- (void)addSaveContactAction:(UIAlertController *)alertController forSelectedContact:(PCContact *)selectedContact {
    __weak UIViewController *blocksafeSelf = self;
    [self alertController:alertController
       addActionWithTitle:NSLocalizedString(@"Save Contact", nil)
                    style:UIAlertActionStyleDefault
                andAction:^(UIAlertAction * _Nonnull action) {
                    
                    [blocksafeSelf saveContact:selectedContact];
                }];
}

- (void)showActionsForSelectedContact:(PCContact *)selectedContact {

    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:selectedContact.firstName
                                                                             message:nil
                                                                      preferredStyle:UIAlertControllerStyleActionSheet];
    
    
    
    [self addSaveContactAction:alertController forSelectedContact:selectedContact];
    [self addCancelAction:alertController];
    
    [self presentViewController:alertController animated:YES completion:nil];
}

@end
