//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import "ContactsDisplayViewController.h"
#import "ContactSearchViewController.h"
#import "UIViewController+Dismiss.h"
#import "UIViewController+RightBarButtonAction.h"

@interface ContactSearchViewController (Private)

@property (nonatomic, strong) NSArray *contacts;

@end

@interface ContactsDisplayViewController ()

@property (nonatomic, strong) NSArray *contacts;
@property (nonatomic, strong) UISearchController *searchController;
@property (nonatomic, strong) ContactSearchViewController *contactSearchViewController;
@property (strong, nonatomic) NSIndexPath *selectedIndexPath;

@end

@implementation ContactsDisplayViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    UIStoryboard *storyBoard = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
    self.contactSearchViewController = (ContactSearchViewController *)[storyBoard instantiateViewControllerWithIdentifier: @"ContactSearchViewController"];
    self.contactSearchViewController.contacts = self.contacts;
    self.contactSearchViewController.searchMasterController = self;
    
    self.searchController = [[UISearchController alloc] initWithSearchResultsController:self.contactSearchViewController];
    self.searchController.searchResultsUpdater = self.contactSearchViewController;
    [self.searchController.searchBar sizeToFit];
    self.tableView.tableHeaderView = self.searchController.searchBar;
    self.searchController.dimsBackgroundDuringPresentation = NO;
    self.definesPresentationContext = YES;
    // Adding cancel button in view controller.
    [self addCancelButton];
    
    // Adding action items in RightBarButton.
    [self addRightBarButtonItemWithActions:[NSNumber numberWithInt:accountInfoRightBarAction], [NSNumber numberWithInt:signOutRightBarAction], nil];
    
    self.title = [NSString stringWithFormat:NSLocalizedString(@"%d Contacts", nil), self.contacts.count];
    [self.tableView scrollToRowAtIndexPath:self.selectedIndexPath atScrollPosition:UITableViewScrollPositionTop animated:NO];
}

- (NSArray *)dataSource {

    return self.contacts;
}

@end
