//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import "GenreListViewController.h"
#import "UIViewController+Dismiss.h"
#import "NSArray+Addition.h"
#import "GenreResourcesViewController.h"
#import "PCAPISDKCommonHeader.h"

@interface BaseTableViewController (Private)

@property (nonatomic, strong) NSString *emptyMessage;

@end

@interface ResourceGroupByViewController (Private)

@property (nonatomic, strong) NSArray *resourceList;

@end


@implementation GenreListViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.navigationItem.title = NSLocalizedString(@"Genre", nil);
    self.emptyMessage = NSLocalizedString(@"Genre is empty", nil);
    
}

#pragma mark -
#pragma mark TableView methods

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [self.resourceList count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"groupByCell" forIndexPath:indexPath];
    PCGenre *genre =  [self.resourceList objectAtIndex:indexPath.row];
    cell.textLabel.text = genre.name;
    return cell;
}


#pragma mark -
#pragma mark UITableView delegate methods

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    PCGenre *selectedGenre = [self.resourceList objectAtIndex:indexPath.row];
    UIStoryboard *storyBoard = [UIStoryboard storyboardWithName:@"Main" bundle:nil];
    
    GenreResourcesViewController *controller = (GenreResourcesViewController *)[storyBoard instantiateViewControllerWithIdentifier: @"GenreResourcesViewController"];
    controller.title =  selectedGenre.name;
    controller.genre = selectedGenre;
    [self.navigationController pushViewController:controller animated:YES];
}


@end
