//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import <XCTest/XCTest.h>
#import "PCTestConstants.h"

@interface PCFetchContactAPITests : XCTestCase

@end

@implementation PCFetchContactAPITests

- (void)setUp {
    [super setUp];
    // Put setup code here. This method is called before the invocation of each test method in the class.
}

- (void)tearDown {
    // Put teardown code here. This method is called after the invocation of each test method in the class.
    [super tearDown];
}

/*!
 * Test Case: auth token is a required parameter. SDK should throw an exception in case auth token is nil.
 */
- (void)testNilAuthToken {
    // If User is not logged in, fetch contact api should throw an exception
    if (![[PCAPISDK sharedInstance] isUserLoggedIn]) {
        
        XCTAssertThrows([[PCAPISDK sharedInstance] fetchContactsWithCompletionHandler:^(NSArray *contacts, PCAPIQueryResponse *response) {}],@"Fetch Contact API with nil access token");
        
    }
}

/*!
 * Test Case: If response code is 200, fetch contact API returns an array which contains PCContact object. In all other cases (error),it will return nil value.
 */
- (void)testFetchContact {
    
    if ([[PCAPISDK sharedInstance] isUserLoggedIn]) {
        
         XCTestExpectation *expectation = [self expectationWithDescription:@"Fetch contact API"];
        
        [[PCAPISDK sharedInstance] fetchContactsWithCompletionHandler:^(NSArray *contacts, PCAPIQueryResponse *response) {
            
            switch (response.urlResponse.statusCode) {
                    
                case PCAPIResponseCodeOK: {
                    
                    if (contacts.count) {
                        XCTAssertTrue([[contacts objectAtIndex:0] isMemberOfClass:[PCContact class]], @"Fetch API returns a object of PCContact");
                    } else {
                        XCTFail(@"Test case failed due to absence of contact");
                    }
                }
                    break;
                    
                default:
                    XCTFail(@"fetch contact API failed");
                    break;
            }
            [expectation fulfill];
        }];
        
        [self waitForExpectationsWithTimeout:ExpectationTimeOut handler:^(NSError *error) {
            if (error) {
                NSLog(@"Timeout Error: %@", error);
            }
        }];
        
    } else {
        XCTFail(@"Test Failed due to nil access token");
    }
}
@end
