//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import "PCFile.h"
#import <CoreData/CoreData.h>

/*!
 * This class stores the metadata information of audio file.
 */
@interface PCAudio : PCFile

/*!
 * Maps to the ID3 album field for MP3 files.
 */
@property (nonatomic, readonly, copy) NSString *album;

/*!
 * Maps to the ID3 artist field for MP3 files.
 */
@property (nonatomic, readonly, copy) NSString *artist;

/*!
 * Maps to the ID3 genre field for MP3 files.
 */
@property (nonatomic, readonly, copy) NSString *genre;

/*!
 * The duration of an audio file.
 */
@property (nonatomic, readonly, strong) NSNumber *duration;

/*!
 * Maps to the ID3 title field for MP3 files.
 */
@property (nonatomic, readonly, copy) NSString *title;

/*!
 * Call this methods to create a PCAudio using a managedObjectID. managedObjectID is mapped with coredata object and a PCAudio is created out of the values copied from the coredata object.
 */
- (id)initWithDBResourceID:(NSManagedObjectID *)managedObjectID;

@end
