//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import "PCFile.h"

@class PCAPI;
@class PCAPIQueryResponse;

@interface PCFile (FileOperation)

/*!
 * Call this method to download thumbnail image of any file.
 * @param completion This block gets called on the completion of thumbnail fetch process. PCAPIQueryResponse stores the location of downloaded thumbnail.
 * @return A PCAPI object which is downloading the thumbnail image.
*/

- (PCAPI *)downloadThumbnailWithCompletionHandler:(void (^)(PCAPIQueryResponse *response))completion;

/*!
 * Call this method to download a file. The file is downloaded to a temporary path and the file will be removed once the api which downloaded the file is released. So move the file to a different location in completion callback.
 * @param progress indicates the upload progress of the file.
 * @param completion This block gets called on the completion of a file download. PCAPIQueryResponse stores the location of downloaded file.
 * @return A PCAPI object which is downloading the file.
 */

- (PCAPI *)downloadFileWithProgressHandler:(void (^)(float progress))progress andCompletionHandler:(void (^)(PCAPIQueryResponse *response))completion;

@end
