//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import <UIKit/UIKit.h>

@class CustomDatePicker;

// CustomDatePicker done block
typedef void(^CustomDateDoneBlock)(CustomDatePicker *picker, id selectedDate);
// CustomDatePicker clear or cancel block
typedef void(^CustomDateCancelBlock)(CustomDatePicker *picker);

@interface CustomDatePicker : UIControl {
    
}

/*!
 * call this method to initialize  custom data picker.
 * \param title - required to display title in custom date picker view.
 * \param titleFont - required to set value for title font in custom date picker view.
 * \param selectedDate - required to select default date in custom date picker view.
 * \param doneBlock This block gets called when done button clicked.
 * \param cancelBlock This block gets called when cancel or clear button clicked.
 */
- (instancetype)initWithTitle : (NSString *)title
                    titleFont : (UIFont *)titleFont
               datePickerMode : (UIDatePickerMode)datePickerMode
                 selectedDate : (NSDate *)selectedDate
                    doneBlock : (CustomDateDoneBlock)doneBlock
                  cancelBlock : (CustomDateCancelBlock)cancelBlock;

/*!
 * call this method to display custom data picker.
 */
- (void) showPickerView;

@end
