//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import <UIKit/UIKit.h>

@class PCShareItem;

typedef enum {
    
    deleteShareAction
} ShareAction;

@interface UIViewController (Share)

/*!
 * call this method to trigger share actions like delete share.
 * @param selectedShare share on which action needs to be performed.
 */
- (void)showActionsForSelectedShare:(PCShareItem *)selectedShare;

/*!
 * call this method to silently execute an action for any share.
 */
- (void)executeAction:(ShareAction)action forShare:(PCShareItem *)share;

/*!
 * Implement this method in the viewController consuming this category class. This method can implement custom actions which needs to be implemented before performing a particular action. For eg. start a spinner.
 * @param action the action that is going to be executed.
 */
- (void)didBeginDoingShareAction:(ShareAction)action;

/*!
 * Implement this method in the viewController consuming this category class. This method can implement custom actions which needs to be implemented after performing a particular action. For eg. stop a spinner, reload a tableView etc.
 * @param action the action that is being executed.
 * @param result result of action, if any.
 * @param response response of the action, if any.
 */
- (void)didFinishDoingAction:(ShareAction)action onShare:(id)share result:(id)result response:(id)response;
@end
