//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import <Foundation/Foundation.h>

// PCAPILoggerProtocol used to log start and finish of the NSURLSessionTask.
@protocol PCAPILoggerProtocol <NSObject>

typedef enum {
    
    PCAPILoggerLevelInfo,
    PCAPILoggerLevelDebug,
    PCAPILoggerLevelError,
    PCAPILoggerLevelFatel,
    
    
} PCAPILoggerLevel;

@property (nonatomic, assign) PCAPILoggerLevel logLevel;

- (void)URLSessionTaskDidStart:(NSURLSessionTask *)task;
- (void)URLSessionTaskDidFinish:(NSURLSessionTask *)task withResponseObject:(id)responseObject withError:(NSError *)error;
- (void)messageLogger:(id)string;

@end
