//Copyright © 2015-2016, Verizon and/or its Licensors. All rights reserved.

#import "PCResourceAPIParams.h"

/*!
 * PCUploadAPIParams stores all the parameters required to upload a file to cloud.
 */
@interface PCUploadAPIParams : PCResourceAPIParams

/*!
 * The path to the folder where file has to be uploaded. (required)
 */
@property (nonatomic, copy) NSString *path;

/*!
 * Name of the file to be uploaded. (required)
 */
@property (nonatomic, copy) NSString *name;

/*!
 * Size of the file to be uploaded. (required)
 */
@property (nonatomic, assign, readonly) long long size;

/*!
 * Checksum of the file/chunk. (required)
 */
@property (nonatomic, copy, readonly) NSString *checkSum;

/*!
 * Should be set to false, in case the file binary has to be uploaded with single request. Otherwise should be set to true when file binary has to be uploaded in multiple request.
 */
@property (nonatomic, assign, readonly) BOOL chunk;

@end
